/* converted to C by moof.  7/11/91

 # was A perl script to connect to the 'weather server' at
 # Michigan and get the forcast for whatever city
 # you want (3 letter code -- columbus 'cmh' by default).
 #
 # Alternatively, you can get the current information for
 # a state if you enter a 2 letter code.
 #
 # --FNA 6/28/91

*/
#define DEBUG 0
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
extern int errno;
extern char *strstr();

#define OUTBUFSIZE 512
#define SERVER  "downwind.sprl.umich.edu"
#define PORT    3000
int SHOWIT = 0;
int X_EXIT = 0;
int HELP_INFO = 0;
int FIRSTTIME = 1;

main(argc, argv)
int argc;
char *argv[];
{
	char *city;
	int isstate, i;
	char c;
	struct hostent *ph;
	struct sockaddr_in sin;
	int sock;
	char outbuf[OUTBUFSIZE];
	char curline[255];
	int readfds;

	city = argv[1];
	if (argc < 2 || strcmp(city, "") == 0) city = "roc";
	switch (strlen(city)) {
		case 3:
			isstate = 0;
			break;
		case 2:
			isstate = 1;
			break;
		default:
			fprintf(stderr, "Must be either a 2 letter state code or 3 letter city code.\n");
			exit (1);
	}
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		fprintf(stderr, "can't get socket\n");
		exit(1);
	}
	ph = gethostbyname(SERVER);
	if (ph == NULL) {
		fprintf(stderr, "bad server name\n");
		exit(1);
	}
	sin.sin_family = AF_INET;
	bcopy(ph->h_addr, &sin.sin_addr, ph->h_length);
	sin.sin_port = htons(PORT);
	if (connect(sock, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
		fprintf(stderr, "couldn't connect to server\n");
		exit(1);
	}

	for (i=0; read(sock,&c,1);) {
		if (c == '\n') {
			if (SHOWIT == 1 || DEBUG) {
				printf("%s\n", curline);
			}
			i = 0;
			curline[i] = '\0';
			continue; 
		}
		if (c == '\r')  continue; 
		curline[i++] = c;
		curline[i] = '\0';

		if (strstr(curline, "?) Help")) {
			curline[i=0] = '\0';
			if (++HELP_INFO >= 3) {
				sprintf(outbuf, "X\n");
				Write(sock, outbuf, strlen(outbuf));
			}
		}
		else if (strstr(curline, "Press Return for menu, or enter 3 letter forecast city code:")) {
			if (isstate) {
				sprintf(outbuf, "\n");
				Write(sock, outbuf, strlen(outbuf));
				curline[i=0] = '\0';
			} else {
				SHOWIT = 1;
				FIRSTTIME = 0;
				sprintf(outbuf, "%s\n", city);
				Write(sock, outbuf, strlen(outbuf));
				curline[i=0] = '\0';
			}
		}
		else if (strstr(curline, "X) Exit program")) {
			if (isstate) {
			    switch (++X_EXIT) {
				case 1:
				    SHOWIT = 0;
				    sprintf(outbuf, "3\n");
				    Write(sock, outbuf, strlen(outbuf));
				    break;
				case 2:
				    SHOWIT = 0;
				    sprintf(outbuf, "1\n");
				    Write(sock, outbuf, strlen(outbuf));
				    curline[i=0] = '\0';
				    break;
				default:
				    sprintf(outbuf,"X\n");
				    Write(sock, outbuf, strlen(outbuf));
			    }
			} else {
			    sprintf(outbuf,"X\n");
			    Write(sock, outbuf, strlen(outbuf));
			}
			curline[i=0] = '\0';
		}
		else if (strstr(curline,"Invalid 3-letter city code.")) {
			sprintf(outbuf,"X\n");
			Write(sock, outbuf, strlen(outbuf));
			fprintf(stderr, "%s is an invalid 3 letter city code.\n", city);
			SHOWIT = 0;
			curline[i=0] = '\0';
		}
		else if (strstr(curline,"Invalid city or state code.")) {
			sprintf(outbuf,"X\n");
			Write(sock, outbuf, strlen(outbuf));
			fprintf(stderr, "%s is an invalid 3 letter city code.\n", city);
			SHOWIT = 0;
			curline[i=0] = '\0';
		}
		else if (strstr(curline,"Press Return to display") && strstr(curline, "M for menu:")) {
			curline[i=0] = '\0';
			SHOWIT = 1;
			sprintf(outbuf, "\n");
			Write(sock, outbuf, strlen(outbuf));
		}
		else if (strstr(curline,"Press Return to continue printing or M to return to menu:")) {
			curline[i=0] = '\0';
			SHOWIT = 1;
			sprintf(outbuf, "\n");
			Write(sock, outbuf, strlen(outbuf));
		}
		else if (strstr(curline,"Press Return to continue:")) {
			curline[i=0] = '\0';
			SHOWIT = 1;
			sprintf(outbuf, "\n");
			Write(sock, outbuf, strlen(outbuf));
		}
		else if (strstr(curline, "Enter 2-letter code of state or province:")) {
			curline[i=0] = '\0';
			SHOWIT = 1;
			FIRSTTIME = 0;
			sprintf(outbuf,"%s\n", city);
			Write(sock, outbuf, strlen(outbuf));
		}
		else if (strstr(curline, "CITY FORECAST MENU") && FIRSTTIME == 0) {
			SHOWIT = 0;
			curline[i=0] = '\0';
		}
		else if (strstr(curline,"CURRENT WEATHER MENU") && FIRSTTIME == 0) {
			SHOWIT = 0;
			curline[i=0] = '\0';
		}
	}
	close(sock);
	exit(0);
}

#ifndef ANSI
char *
strstr(s1, s2)
char *s1;
char *s2;
{
	char *cp1, *cp2;

	while (1) {
		for (;*s1 && *s1 != *s2; s1++);
		if (*s1 == '\0') break;
		cp1 = s1;
		cp2 = s2;
		for (;*cp2 && *cp1 && *cp1 == *cp2; cp1++, cp2++) ;
		if (*cp2 == '\0') return(s1);
		s1++;
	}
	return(NULL);
}
#endif

Write(fd, buf, len)
int fd, len;
char *buf;
{
	if (DEBUG) {
		printf("%s", buf);
	}
	write(fd, buf, len);
}

